mod solutions;
mod utils;
use clap::Parser;
use utils::{run_solution, Problem};

#[derive(Parser, Debug)]
#[command(
    name = "Rosalind Problems",
    version = "v0.0.0",
    author = "Peter Vlasveld <peter@vlasveld.info>",
    about = "Solves Problems from rosalind.info"
)]
struct Args {
    #[arg(short, long)]
    problem: Problem,

    #[arg(short, long)]
    input_file: String,

    #[arg(short, long, default_value = "output.txt")]
    output_file: String,
}

fn main() {
    let args = Args::parse();
    run_solution(args.problem, &args.input_file, &args.output_file);
}
