pub fn iev(file_content: String) -> String {
    let prob: [f64; 6] = [1.0, 1.0, 1.0, 0.75, 0.5, 0.0];
    let mut result: f64 = file_content
        .trim()
        .split_whitespace()
        .zip(prob.iter())
        .map(|(a, b)| a.parse::<f64>().unwrap() * b)
        .sum();
    // the problem specifies that the assumption is that every couple has exactly 2 offspring,
    // thus, we multiply the result by 2 here.
    result *= 2.0;
    return result.to_string();
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_iev() {
        let input_content = "1 0 0 1 0 1".to_string();
        let expected = "3.5";
        assert_eq!(iev(input_content), expected);
    }
}
